import QtQuick 2.0

Column {
    property alias host: ipAddressInputText.text
    property alias port: ipPortInputText.text
    property alias pass: passwordInputText.text
    spacing: 10
    Text {
     color: "#919191"
     font.family: "Ubuntu"
     font.pointSize: uiSettings.btm
     text: Langpack.barPreferencesTabProjectLabelServerHost
    }

    Rectangle {
        id: ipAddressInput
        width: parent.width
        height: uiSettings.b
        color: "#00000000"
        border.color: "#919191"
        border.width: uiSettings.sf/4
        TextInput {
            id: ipAddressInputText
            anchors.fill: parent
            horizontalAlignment: TextInput.AlignHCenter
            verticalAlignment: TextInput.AlignVCenter
            color: "white"
            font.family: "Ubuntu"
            font.pointSize: uiSettings.btm
            inputMethodHints: Qt.ImhDigitsOnly
        }
    }
    Text {
     color: "#919191"
     font.family: "Ubuntu"
     font.pointSize: uiSettings.btm
     text: Langpack.barPreferencesTabProjectLabelServerPort
    }
    Rectangle {
        id: ipPortInput
        width: parent.width
        height: uiSettings.b
        color: "#00000000"
        border.color: "#919191"
        border.width: uiSettings.sf/4
        TextInput {
            id: ipPortInputText
            anchors.fill: parent
            horizontalAlignment: TextInput.AlignHCenter
            verticalAlignment: TextInput.AlignVCenter
            property int port: 0
            font.family: "Ubuntu"
            color: "white"
            font.pointSize: uiSettings.btm
            text: "55555"
            validator: IntValidator{bottom:0; top:65535}
            inputMethodHints: Qt.ImhDigitsOnly
        }
    }
    Rectangle {
        id: passwordInput
        width: parent.width
        height: uiSettings.b
        color: "#00000000"
        border.color: "#919191"
        border.width: uiSettings.sf/4
        visible: false
        TextInput {
            id: passwordInputText
            anchors.centerIn: parent
            property int port: 0
            color: "white"
            font.family: "Ubuntu"
            font.pointSize: uiSettings.btm
            text: "password"

            inputMask:  ""
        }
    }
    Component.onCompleted: {
        host = Global.projectServerHost()
        port = Global.projectServerPort()
        pass = Global.projectServerPassword()
    }
    function saveSettings() {
        Global.setProjectServer(host, parseInt(port), pass);
    }
}
