import QtQuick 2.4
import Trogl 1.0

Item {
    id: _Btn
    width: uiSettings.b
    height: uiSettings.b

    signal pressed(int mx, int my);
    signal released(int mx, int my);
    signal lpressed(int mx, int my);
    signal clicked(int mx, int my);
    signal moved(int mx, int my);

    property real radius: uiSettings.br
    property bool btnActive: false
    property alias btnPressed: ma.pressed

    property alias backGround: _backbround
    property alias img: _icon
    property alias text: _text
    property alias border: _border.border

    property color borderNormal: Skin.buttonGrayBorderNormal
    property color borderHighLight: Skin.buttonGrayBorderHighLight

    Rectangle {
        id: _backbround
        anchors.fill: parent
        radius: _Btn.radius
        gradient: Skin.buttonGrayBackground
    }
    TroglImage {
        id: _icon
        anchors.fill: parent
//        width: _Btn.width
//        height: _Btn.height
        visible: text.text === ""
    }
    Text {
        id: _text
        font.family: "Ubuntu"
        font.bold: true
        style: Text.Normal
        color: "#dddddd"
        anchors.centerIn: parent
    }
    Rectangle {
        id: _border
        anchors.fill: _backbround
        radius: _Btn.radius
        color: "#00000000"
        border.color: (_Btn.btnPressed || _Btn.btnActive)?borderHighLight:borderNormal
        border.width: uiSettings.bf
    }
    MouseArea {
        id: ma
        anchors.fill: parent
        onPressed: _Btn.pressed(mouseX, mouseY);
        onReleased:_Btn.released(mouseX, mouseY);
        onPressAndHold: _Btn.lpressed(mouseX, mouseY);
        onClicked: {
            Audio.playTouch();
            _Btn.clicked(mouseX, mouseY);
        }
        onPositionChanged: _Btn.moved(mouseX, mouseY)
    }

}
