import QtQuick 2.0
import "../TroglControls"
import "../"

Column {
    id: ccol
    property alias host: ipAddressInputText.text
    property alias port: ipPortInputText.text
    property alias pass: passwordInputText.text
    property Component keyBoardCompo: Qt.createComponent("qrc:/ServerKeyboard.qml")
    property ServerKeyboard keyBoard: null

    spacing: 10
    Text {
     color: "#919191"
     font.family: "Ubuntu"
     font.pointSize: uiSettings.btm
     text: Langpack.barPreferencesTabProjectLabelServerHost
    }

    function kbOpen() {
        if(keyBoard == null)
        {
            keyBoard = keyBoardCompo.createObject(dynBarsContainer)
            keyBoard.done.connect(kbDone)
            keyBoard.closed.connect(kbClosed)
        }

        keyBoard.setData(host, port)
        keyBoard.open()
    }

    function kbDone() {
        if(keyBoard)
        {
            host = keyBoard.ip()
            port = keyBoard.port()
            keyBoard.close()
        }
    }
    function kbClosed() {
        if(keyBoard)
            keyBoard.destroy()
    }

    Rectangle {
        id: ipAddressInput
        width: parent.width
        height: uiSettings.b
        color: "#00000000"
        border.color: "#919191"
        border.width: uiSettings.sf/4
        Text {
            id: ipAddressInputText
            anchors.fill: parent
            horizontalAlignment: TextInput.AlignHCenter
            verticalAlignment: TextInput.AlignVCenter
            color: "white"
            font.family: "Ubuntu"
            font.pointSize: uiSettings.btm
        }
        MouseArea {
            anchors.fill: parent
            onClicked: kbOpen()
        }
    }
    Text {
     color: "#919191"
     font.family: "Ubuntu"
     font.pointSize: uiSettings.btm
     text: Langpack.barPreferencesTabProjectLabelServerPort
    }
    Rectangle {
        id: ipPortInput
        width: parent.width
        height: uiSettings.b
        color: "#00000000"
        border.color: "#919191"
        border.width: uiSettings.sf/4
        Text {
            id: ipPortInputText
            anchors.fill: parent
            horizontalAlignment: TextInput.AlignHCenter
            verticalAlignment: TextInput.AlignVCenter
            property int port: 0
            font.family: "Ubuntu"
            color: "white"
            font.pointSize: uiSettings.btm
            text: "55555"
        }
        MouseArea {
            anchors.fill: parent
            onClicked: kbOpen()
        }
    }
    Rectangle {
        id: passwordInput
        width: parent.width
        height: uiSettings.b
        color: "#00000000"
        border.color: "#919191"
        border.width: uiSettings.sf/4
        visible: false
        TextInput {
            id: passwordInputText
            anchors.centerIn: parent
            property int port: 0
            color: "white"
            font.family: "Ubuntu"
            font.pointSize: uiSettings.btm
            text: "password"

            inputMask:  ""
        }
    }

    Component.onCompleted: {
        host = Global.projectServerHost()
        port = Global.projectServerPort()
        pass = Global.projectServerPassword()
    }
    function saveSettings() {
        Global.setProjectServer(host, parseInt(port), pass);
    }
}
