import QtQuick 2.4
import Trogl 1.0

Item{
    id: _Slider
    width: uiSettings.slbw
    height: uiSettings.slbh
    property real minVal: 0
    property real maxVal: 100
    property real curVal: 0
    property bool intMode: false

    onCurValChanged: {
        curVal = Math.max(Math.min(curVal, maxVal), minVal)
        updateThumbPos()
    }
    onMinValChanged: updateRange()
    onMaxValChanged: updateRange()

    function updateRange() {
        minVal = Math.min(minVal, maxVal)
        maxVal = Math.max(minVal, maxVal)
        curVal = Math.min(Math.max(curVal, minVal), maxVal)
    }

    function valFromY(newY)
    {
        var thh = tumb.height/2;
        var cropY = Math.min(Math.max(newY, thh), workspace.height - thh);
        var tmpVal = minVal + (maxVal - minVal + 1) * (1.0 - (cropY - thh) / (workspace.height - tumb.height));
        curVal = intMode?Math.floor(tmpVal):tmpVal;
    }
    function updateThumbPos(){
        tumb.y = ((workspace.height - tumb.height)*(1.0 - (curVal - minVal)/(maxVal - minVal))).toFixed()
    }
    property Rectangle background: Rectangle  {
        anchors.fill: parent
        color: "#00000000"
    }

    property Rectangle workspace: Rectangle {
        anchors.fill: parent
        radius: tumb.radius
        color: "#00000000"
        border.width: uiSettings.slcw
        border.color: Skin.sliderCtrlBorder
    }
    property Rectangle tumb: Rectangle {
        width: parent.width
        height: Math.max((workspace.height/(maxVal - minVal + 1)).toFixed(), workspace.height/6);
        radius: uiSettings.slrb
        gradient: Skin.sliderCtrlThumb
    }
    Component.onCompleted: {
        background.parent = _Slider
        background.anchors.fill = _Slider

        workspace.parent = _Slider
        tumb.parent = workspace
    }
}
